@/data/kbah/code/FGF/mesoscale/singlebands/sub_pro/READ_ABI_NETCDF_01.PRO
@/data/kbah/code/FGF/mesoscale/singlebands/sub_pro/WRITE_VAL_FROM_GRB_SCALED_NETCDF.PRO
@/data/kbah/code/FGF/mesoscale/singlebands/sub_pro/WRITE_GRB_SCALED_NETCDF.PRO
@/data/kbah/code/FGF/mesoscale/singlebands/sub_pro/SUBSET_DATA.PRO


PRO MESOSCALE_NETCDF_GRB_VAL_NETCDF_FGF
 
 ;;;;;Variables  
    inpre0='/data/kbah/input_data/FGF/mesoscale/'
    outpreg='/data/kbah/output/FGF/mesoscale/GRB/' 
    outprev='/data/kbah/output/FGF/mesoscale/VAL/' 
     
     times=['1200']
     
     FOR ii=1 , 16 DO BEGIN  ;7 ,16
          inpre=inpre0 & bnum=STRING(STRTRIM(ii,1))
    
          IF ii LT 10 THEN bnum='0'+ STRING(STRTRIM(ii,1))
                aband=STRING('band'+bnum)

                nt=n_elements(times)
          for ntime=0,nt-1 do begin
               time=times(ntime)
               outpre1= outpreg &  outpre2= outprev    
              infiles=GET_FILES(inpre=inpre, aband=aband, time=time, ii=ii)
              MAKE_BANDLOOP,infiles, outpre1, outpre2, num_files,ii
           endfor
  ENDFOR  
  
END

FUNCTION SUBSET_XY, data, ii
   xx=data.latlon.dataset(0)
   yy=data.latlon.dataset(1)
   xygats=data.latlon.gats
   x_st=1770 & x_end=x_st+580-1    &   y_st=4675 & y_end=y_st + 328-1
   IF (ii EQ 1 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
        x_st=3540 & x_end=x_st+1160-1    &   y_st=9350 & y_end=y_st + 656-1
   ENDIF
   
   temp_xx=(xx.data(x_st:x_end))      &   temp_yy=(yy.data(y_st: y_end))
   
   s_xx={xx:temp_xx, attr:xx.attr, attrval:xx.attrval}
   s_yy={yy:temp_yy, attr:yy.attr, attrval:yy.attrval}
    
   slatlon={xx:s_xx, yy:s_yy, gats:xygats}
   
   subdata={data:data.data,latlon:slatlon}
   
   RETURN, subdata
   
END
 ;;;;;;;;;;;;;;;sub routines
  
  
  
FUNCTION READ_FILES,infiles,latlonfile, vars=vars, ii=ii
 xx=5534
IF (ii EQ 1 OR ii EQ 3 OR ii EQ 5) THEN xx=11070
  data=READ_ABI_NETCDF_01(infiles,vars=vars, nvars=1, lineele=0, ii=ii)
  latlon=READ_ABI_NETCDF_01(latlonfile,vars=vars, xx=xx, yy=1, nvars=2, lineele=1, ii=ii) 
  datalatlon={data:data, latlon:latlon}
 RETURN, datalatlon 
END


FUNCTION GET_FILES,inpre=inpre, aband=aband, time=time, ii=ii
  IF not keyword_set(inpre) then message, 'Provide input file location'
  IF not keyword_set(aband) then message, 'Provide the band number to process'
  
     inpre2='psc/' ;ncsa'2km/'
    inprele='lineelements/'
    ;IF (ii LE 5 AND ii NE 4) THEN inpre2='' ;'1km/'
    inpred=inpre+inpre2  & inprele='/data/kbah/input_data/FGF/latlon' ;inpre+inprele
    sub1='*'+aband+'*'+time+'*' & sub2='psc_abi_rem_2km_fd_75W_lines_elements.nc' ;'*75W_lines_elements*'   
    IF (ii EQ 1 OR ii EQ 3 OR ii EQ 5) THEN sub2='FGF75W_fulldisk_1km.nc'
    datafiles=FIlE_SEARCH(inpred, sub1)
    print,datafiles
    lineselements=FILE_SEARCH(inprele,sub2)
    info={data:datafiles, lineselements:lineselements}
    RETURN, info
END






PRO MAKE_BANDLOOP,infiles, outpre1,outpre2, num_files,ii
     tot_newfiles=N_ELEMENTS(infiles.data)
     IF (tot_newfiles GE 1) THEN BEGIN  
     FOR jj=0, tot_newfiles-1 DO BEGIN  ;tot_newfiles-1
        spos=STRPOS(infiles.data(jj),'psc_',  /REVERSE_SEARCH)
        epos=STRPOS(infiles.data(jj), '.',    /REVERSE_SEARCH) 
        ;outpost=STRMID(infiles.data(jj), spos-9, (epos+12-spos))
        outpost=STRMID(infiles.data(jj), spos, (epos+3-spos))
        outpre1=outpre1+'GRB_scaled_'+ outpost  
        outpre2=outpre2+'Validation_'+ outpost

        vars=1
        IF (ii LE 6) THEN var=1
  
     data=READ_FILES(infiles.data(jj), infiles(0).lineselements,vars=vars, ii=ii)
    multivar=0
    

    data2=SUBSET_XY(data, ii)
    WRITE_GRB_SCALED_NETCDF,data2, outpre1, multivar,katr, ii=ii
    WRITE_VAL_FROM_GRB_SCALED_NETCDF, outpre1, outpre2, multivar,katr,infiles(0).lineselements, data2, ii=ii

          print,  '   ' ;ii, jj
          print,  '   ' ;ii, jj
          print,  'DONE   ' ;ii, jj
  ENDFOR
  ENDIF 
END
